#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASMyPage : public CWASCommand
{
public:
	CWASMyPage(CWASActor *pActor);
	~CWASMyPage(void);

	void ExecuteAsync(void);

	void SetParameter(bool bFirstLogin, GTOSType eOSType, WSTRING &strLangCode, WSTRING &strTenantName, int nProfileSerial, int nInviteBuddySerial, int nSpecSerial)
	{
		m_bFirstLogin = bFirstLogin;

		m_strLangCode = strLangCode;
		m_strTenantName = strTenantName;

		m_nSerialProfile = nProfileSerial;
		m_nSerialInviteBuddy = nInviteBuddySerial;
		m_nSerialSpec = nSpecSerial;
        m_eOSType = eOSType;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

	//bool LoadSpecInfo(nfc::CIkXMLDom * pDom);
	//bool LoadFAQList(nfc::CIkXMLDom * pDom);
	//bool LoadCacheInfo(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	bool m_bFirstLogin;

	WSTRING m_strLangCode;
	WSTRING m_strTenantName;

	int m_nSerialProfile;
	int m_nSerialSpec;
	int m_nSerialInviteBuddy;
	
    GTOSType m_eOSType;
    
	P_GT_MYPAGE_DATA m_sMyPage;
	P_GT_API_SPEC_DATA m_sSpecInfo;
	int m_nCategoryCacheSerial;

	// FAQ Ʈ 
	p_faqlist_t m_listFAQPrivate;
	faqlist_t	 m_listFAQ;			// WSTRING -> LPCWSTR ȯϿ Ʈ ֱ  ʿϴ!

	std::vector<NE_LEVEL_DATA> m_listLevel;
};
